// Bill and Ted's Shortest Adventure
// FIU High School Programming competition, 2015
// Solution by Steve Lyons
// Updated solution that prints only the minimum cost.
// Uses Dijkstra, single-source shortest path algorithm.

import java.io.*;
import java.util.*;

public class BillAndTed {
	class Year implements Comparable<Year> {
			int t, i, y;
			ArrayList<SpaceTime> adj;
			boolean v;
			public Year(int i) {
				this.i=i;
				this.adj = new ArrayList<SpaceTime>();
				this.v = false;
				this.t = Integer.MAX_VALUE;
			}
			public int compareTo(Year o) {
				return this.t-o.t;
			}
			public String toString() { return Integer.toString(y); }
	}

	class SpaceTime {
		Year to;
		int t;
		public SpaceTime(Year to, int t) {this.to=to;this.t=t;}
	}

	public static void main(String[] args) {
		(new BillAndTed()).run();
	}

	public void run() {
		Scanner in = new Scanner(System.in);
		int famous_people = in.nextInt();
		for(int famous_person = 1; famous_person <= famous_people; famous_person++) {
			int num_years = in.nextInt();
			Year[] years = new Year[num_years];
			Year start = null;
			for(int i = 0; i < num_years; i++) {
				years[i] = new Year(i);
			}
			for(int i = 0; i < num_years; i++) {
				years[i].y = in.nextInt();
				if(years[i].y == 1989) start = years[i];
				for(int j = 0; j < num_years; j++) {
					years[i].adj.add(new SpaceTime(years[j], in.nextInt()));
				}
			}
			int endYear = in.nextInt();
			start.t = 0;
			PriorityQueue<Year> pq = new PriorityQueue<Year>();
			pq.add(start);
			while(!pq.isEmpty()) {
				Year current = pq.poll();
				if(current.y == endYear) {
					System.out.println(current.t);
					break;
				}
				if(!current.v) {
					current.v = true;
					for(SpaceTime st : current.adj) {
						Year to = st.to;
						if(!to.v && current.t + st.t < to.t) {
							to.t = current.t + st.t;
							pq.add(to);
						}
					}
				}
			}
		}
	}
}
